package me.unurled.sacredrealms.sr.data.gson;

import com.google.gson.Gson;
import com.google.gson.JsonElement;
import com.google.gson.JsonPrimitive;
import com.google.gson.JsonSerializationContext;
import com.google.gson.JsonSerializer;
import java.lang.reflect.Type;
import org.bukkit.potion.PotionEffect;

public class PotionEffectSerializer implements JsonSerializer<PotionEffect> {

    @Override
    public JsonElement serialize(PotionEffect potionEffect, Type type,
        JsonSerializationContext jsonSerializationContext) {
        StringBuilder sb = new StringBuilder();
        sb.append("{");
        sb.append(potionEffect.getType().key());
        sb.append(",");
        sb.append(potionEffect.getDuration());
        sb.append(",");
        sb.append(potionEffect.getAmplifier());
        sb.append(",").append(potionEffect.hasParticles());
        sb.append("}");
    return new JsonPrimitive(sb.toString());
    }
}
